\documentclass[12pt]{article}
\usepackage{graphicx}
\usepackage{epstopdf}
\usepackage{amssymb}
\usepackage{amsmath}

\def\ga{\alpha}
\def\gb{\beta}
\def\gc{\gamma}
\def\gd{\delta}
\def\ge{\epsilon}
\def\gz{\zeta}
\def\gy{\eta}
\def\th{\theta}
\def\gi{\iota}
\def\gk{\kappa}
\def\gl{\lambda}
\def\gm{\mu}
\def\gn{\nu}
\def\gx{\xi}
\def\gp{\pi}
\def\gr{\rho}
\def\gs{\sigma}
\def\gt{\tau}
\def\gu{\upsilon}
\def\ph{\phi}
\def\ch{\chi}
\def\ps{\psi}
\def\gw{\omega}

\def\gB{\Beta}
\def\gC{\Gamma}
\def\gD{\Delta}
\def\Th{\Theta}
\def\gL{\Lambda}
\def\gX{\Xi}
\def\gP{\Pi}
\def\gS{\Sigma}
\def\gU{\Upsilon}
\def\Ph{\Phi}
\def\Ps{\Psi}
\def\gW{\Omega}

\def\bA{{\bf A}}
\def\bB{{\bf B}}
\def\bC{{\bf C}}
\def\bD{{\bf D}}
\def\bE{{\bf E}}
\def\bF{{\bf F}}
\def\bG{{\bf G}}
\def\bH{{\bf H}}
\def\bI{{\bf I}}
\def\bJ{{\bf J}}
\def\bK{{\bf K}}
\def\bL{{\bf L}}
\def\bM{{\bf M}}
\def\bN{{\bf N}}
\def\bO{{\bf O}}
\def\bP{{\bf P}}
\def\bQ{{\bf Q}}
\def\bR{{\bf R}}
\def\bS{{\bf S}}
\def\bT{{\bf T}}
\def\bU{{\bf U}}
\def\bV{{\bf V}}
\def\bW{{\bf W}}
\def\bX{{\bf X}}
\def\bY{{\bf Y}}
\def\bZ{{\bf Z}}

\def\cA{{\cal A}}
\def\cB{{\cal B}}
\def\cC{{\cal C}}
\def\cD{{\cal D}}
\def\cE{{\cal E}}
\def\cF{{\cal F}}
\def\cG{{\cal G}}
\def\cH{{\cal H}}
\def\cI{{\cal I}}
\def\cJ{{\cal J}}
\def\cK{{\cal K}}
\def\cL{{\cal L}}
\def\cM{{\cal M}}
\def\cN{{\cal N}}
\def\cO{{\cal O}}
\def\cP{{\cal P}}
\def\cQ{{\cal Q}}
\def\cR{{\cal R}}
\def\cS{{\cal S}}
\def\cT{{\cal T}}
\def\cU{{\cal U}}
\def\cV{{\cal V}}
\def\cW{{\cal W}}
\def\cX{{\cal X}}
\def\cY{{\cal Y}}
\def\cZ{{\cal Z}}


\def\ba{{\bf a}}
\def\bb{{\bf b}}
\def\bc{{\bf c}}
\def\bd{{\bf d}}
\def\be{{\bf e}}
\def\bg{{\bf g}}
\def\bh{{\bf h}}
\def\bi{{\bf i}}
\def\bj{{\bf j}}
\def\bk{{\bf k}}
\def\bl{{\bf l}}
\def\bm{{\bf m}}
\def\bn{{\bf n}}
\def\bo{{\bf o}}
\def\bp{{\bf p}}
\def\bq{{\bf q}}
\def\br{{\bf r}}
\def\bs{{\bf s}}
\def\bt{{\bf t}}
\def\bu{{\bf u}}
\def\bv{{\bf v}}
\def\bw{{\bf w}}
\def\bx{{\bf x}}
\def\by{{\bf y}}
\def\bz{{\bf z}}

\def\b0{{\bf0}}
\def\o{\circ}
\def\x{\times}
\def\d{\partial}
\def\<{\langle}
\def\>{\rangle}
\def\R{{\mathbb R}}
\def\Z{{\mathbb Z}}
\def\Q{{\mathbb Q}}
\def\N{{\mathbb N}}
\def\C{{\mathbb C}}
\def\T{{\mathbb T}}
\def\Cinf{C^\infty}
\def\sb{\subseteq}
\def\sp{\superseteq}
\def\({\left(}
\def\){\right)}
\def\rank{\mbox{rank}\,}
\def\rk{\mbox{rank}\,}
\def\ddt{\frac d{dt}}
\def\corank{\mbox{corank}\,}
\def\cl{\hbox{cl}\,}
\def\im{\hbox{im}\,}
\def\Id{\hbox{Id}}
\def\Diff{\hbox{Diff}}
\def\tv{\pitchfork}
\def\ntv{\not\tv}
\def\codim{\hbox{codim}\,}
\def\tr{\hbox{tr}\,}
\def\cosec{\hbox{cosec}\,}
\def\const{\hbox{const}}
\def\lc{\lceil}
\def\rc{\rceil}
\def\lf{\lfloor}
\def\rf{\rfloor}
\def\sech{\hbox{sech}\,}
\def\csch{\hbox{csch}\,}
\def\grad{\hbox{grad}\,}
\def\nbhd{neighbourhood}
\def\dlim{\displaystyle\lim}
\def\dfrac#1#2{\displaystyle{#1\over#2}}
\def\dsum{\displaystyle\sum}
\def\dint{\displaystyle\int}
\def\diint{\displaystyle\iint}
\def\diiint{\displaystyle\iiint}
\def\doint{\displaystyle\oint}
\def\tlim{\textstyle\lim}
\def\tfrac#1#2{\textstyle{#1\over#2}}
\def\tsum{\textstyle\sum}
\def\tint{\textstyle\int}
\def\del{\nabla}
\def\div{\hbox{div}\,}
\def\curl{\hbox{curl}\,}
\def\intL{\int\limits}
\def\iintL{\iint\limits}
\def\iiintL{\iiint\limits}

\def\abs{\hbox{abs}\,}
\def\sgn{\hbox{sgn}\,}
\def\dom{\hbox{dom}\,}


\def\eval{\,\Bigl.\Bigl|}



\def\drawbox#1{\lower6pt\hbox{{\vbox{\hrule\hbox{\vrule\kern15pt
   \vbox{\kern10pt\vbox{\hbox{#1}}\kern10pt} 
   \kern18pt\vrule}\hrule}}}}

\def\picture #1 by #2 (#3){
  \medbreak
		$$\vbox to #2{
    \hrule width #1 height 0pt depth 0pt
    \vfill
    \special{picture #3}
  }$$
}

\def\scaledpicture #1 by #2 (#3 scaled #4){
  \dimen0=#1 
		\dimen1=#2
  \divide\dimen0 by 1000 
   \multiply\dimen0 by #4
  \divide\dimen1 by 1000 
   \multiply\dimen1 by #4
  \picture \dimen0 by \dimen1 (#3 scaled #4)}
%\input mypars
%The following are plain tex style parameters 

\baselineskip=12pt
\hoffset=0pt
\voffset=0 cm
\leftskip=0pt
\rightskip=0pt
\parindent=0cm

%And these are latex style parameters

\headsep=0cm
\headheight=0cm
\evensidemargin=0cm
\oddsidemargin=0cm
\parskip=12pt
\textwidth=16.5 true cm
\textheight=22 true cm
\topmargin=1cm

\def\Gr{Gr\"obner}
\def\kn{k[x_1,\dots,x_n]}
\def\lc{\mbox{\sc lc}}
\def\lt{\mbox{\sc lt}}
\def\lp{\mbox{\sc lp}}
\def\gcd{\mbox{\sc gcd}}
\def\lcm{\mbox{\sc lcm}}
\def\red#1{\stackrel{#1}{\longrightarrow}}
\def\redplus#1{\stackrel{#1}{\longrightarrow}_+}

\newtheorem{theorem}{Theorem}[section]
\newtheorem{lemma}{Lemma}[section]
\newtheorem{definition}{Definition}[section]
\newtheorem{example}{Example}[section]
\newtheorem{corollary}{Corollary}[section]

\newenvironment{proof}
{\begin{trivlist}
\item[\hskip \labelsep {\bf Proof.}]
}
{\hfill$\Box$
\end{trivlist}}
           

\def\pagenumbers{\headline={\iftitle\hfil\global\titlefalse                     
   \else\hss\rm\folio\hss\fi}}                                                  
\newtoks\option                                                                 
\newtoks\solnhead                                                               
\newtoks\sheetname                                                              
\option={,}                                                                     
\def\separate#1,#2@{\def\optionid{#1}\def\optionname{#2}}                      
\def\fullwidth{\everypar{}\parindent=0pt\relax}                                 

\def\maketitle{
\begin{center}
{\sc Victoria University of Wellington\\
School of Mathematics, Statistics and Operations Research}\\
\smallskip
{\sl
Te Kura M{\=a}tai Tatauranga, Rangahau P{\=u}naha}
\end{center}
\expandafter\separate\the\option@
\hbox to\hsize{\hrulefill}
\nointerlineskip
\vskip3pt                                  
\hbox
to\hsize{\strut\rlap{\optionid}\hfill{\sc\optionname}\hfill\llap{\number\year}}          
\nointerlineskip
\vskip2pt
\hbox to\hsize{\hrulefill}}

\let\filbreak=\relax                                                           
\def\head{\filbreak\vskip 18pt\fullwidth                                    
   \def\filbreak{\global\let\filbreak=\fillbreak}%                            
   \centerline{\large\bf \the\sheetname}\nobreak
   \vskip 12pt minus 3pt}                                                       
\def\tutorial{\sheetname={Tutorial}\head}                                      
\def\assignment{\sheetname={Assignment}\head}                                  
\def\sheet#1{\sheetname={#1}\head}                                             
\def\showdue#1{\hbox to\hsize{\hfil Due: #1}
\vskip 5pt minus 3pt}

\leftmargin=0pt              

\begin{document}

\option={MATH 437,Gr\"obner Bases and Their Applications}        
\maketitle
\medskip 
\setcounter{section}7
\section{Buchberger's Algorithm}



\subsection{Buchberger's Algorithm}

Buchberger's Theorem shows us that the obstruction to a given set, $G$, being a
{\Gr} basis is the irreducibility of some S--polynomial for a pair of elements of
the set. This provides a strategy for generating a {\Gr} basis from the given set of
generators for an ideal as follows:
\begin{itemize}
\item
calculate all S--polynomials
\item
reduce each via $G$ and add any non-zero remainders to $G$
\item
repeat until all S--polynomials reduce.
\end{itemize}

\fbox{\bf Buchberger's Algorithm}
\begin{itemize}
\item
{\bf INPUT:} $F=\{f_1,\dots,f_s\}\subseteq\kn$, $f_i\neq0$ for all $i$.
\item
{\bf INITIAL VALUES:} $G:=F$, $\cG=\{\,\{f_i,f_j\}\,:\,f_i\neq f_j\in G\}$.
\item
{\bf ALGORITHM: While $\cG\neq\emptyset$ do}
\begin{itemize}
\item
choose $\{f,g\}\in\cG$
\item
$\cG:=\cG-\{\{f,g\}\}$
\item
$S(f,g)\redplus{G}h$
\item
{\bf IF} $h\neq0$, {\bf THEN}
\begin{eqnarray*}
\cG&:=&\cG\cup\{\,\{u,h\}\,:\,u\in G\}\\
G&:=&G\cup\{h\}
\end{eqnarray*}
\end{itemize}
{\bf OUTPUT:} $G$, a {\Gr} basis for $\<F\>$.
\end{itemize}

There are two key things that need to be proved before we can accept this algorithm:
\begin{enumerate}
\item
does the algorithm terminate?
\item
is $G$ a {\Gr} basis?
\end{enumerate}

{\bf Proof of (1).}  In the algorithm we generate a chain of sets
\[
G_1\subset G_2\subset \dots
\]
where $G_{i+1}=G_i\cup\{h_i\}$ and $h_i$ is reduced with respect to $G_i$. It
follows that $\lt(h_i)\notin\lt(G_i)$ and hence we have an ascending chain of
ideals:
\[
\lt(G_1)\subseteq\lt(G_2)\subseteq\dots
\]
By the ACC this chain must terminate.

{\bf Proof of (2).} If $G$ is the terminating set then $S(g_i,g_j)\redplus{G}0$ and
by Buchberger's Theorem, $G$ is a {\Gr} basis.

{\bf Example.} Find a {\Gr} basis for the ideal generated by $f_1=y^2+yx+x^2$,
$f_2=y+x$, $f_3=y$ in $\Q[x,y]$ with respect to {\sc lex} ordering with $y>x$.

\fbox{Step 0}
\begin{eqnarray*}
\\[-1.5cm]
G&:=&\{y^2+yx+x^2, y+x, y\}\\
\cG&:=&\{\{f_1,f_2\},\{f_1,f_3\},\{f_2,f_3\}\}
\end{eqnarray*}

\fbox{Step 1}
\\[-1cm]
\begin{itemize}
\item
Choose $\{f_1,f_2\}\in\cG$. 
\item
$S(f_1,f_2)=\frac{y^2}{y^2}(y^2+yx+x^2)-\frac{y^2}{y}(y+x)=x^2$. Since $\lt(f_i)$
does not divide $\lt(x^2)$ for any $i=1,2,3$, $h=x^2$ is reduced modulo $G$.
\end{itemize}
\begin{eqnarray*}
\\[-1.5cm]
G&:=&\{y^2+yx+x^2, y+x, y,x^2\}\\
\cG&:=&\{\{f_1,f_3\},\{f_2,f_3\},\{f_1,f_4\},\{f_2,f_4\},\{f_3,f_4\}\}
\end{eqnarray*}
where $f_4=x^2$.

\fbox{Step 2}
\\[-1cm]
\begin{itemize}
\item
Choose $\{f_1,f_3\}\in\cG$. 
\item
$S(f_1,f_3)=\frac{y^2}{y^2}(y^2+yx+x^2)-\frac{y^2}{y}(y)=yx+x^2$. Now
$yx+x^2\red{f_2}0$.
\end{itemize}
\begin{eqnarray*}
\\[-1.5cm]
G&:=&\{y^2+yx+x^2, y+x, y,x^2\}\\
\cG&:=&\{\{f_2,f_3\},\{f_1,f_4\},\{f_2,f_4\},\{f_3,f_4\}\}
\end{eqnarray*}


\fbox{Step 3}
\\[-1cm]
\begin{itemize}
\item
Choose $\{f_2,f_3\}\in\cG$. 
\item
$S(f_2,f_3)=\frac{y}{y}(y+x)-\frac{y}{y}(y)=x$ which is reduced $\mod G$.
\end{itemize}
\begin{eqnarray*}
\\[-1.5cm]
G&:=&\{y^2+yx+x^2, y+x, y,x^2,x\}\\
\cG&:=&\{\{f_1,f_4\},\{f_2,f_4\},\{f_3,f_4\},\{f_1,f_5\},\{f_2,f_5\},\{f_3,f_5\},
\{f_4,f_5\}\}
\end{eqnarray*}

\fbox{Step 4\dots}
\newline
Since now $x$ and $y$ are in $G$, it is fairly clear that $S(f_i,f_j)\redplus{G}0$
for all $(f_i,f_j)\in\cG$. The algorithm terminates. A {\Gr} basis for the ideal is
\[
G=\{y^2+yx+x^2, y+x, y,x^2,x\}.
\]


\subsection{Reduced {\Gr} Bases}

In the example we applied Buchberger's Algorithm to generate a {\Gr} basis for
the ideal $\<y^2+yx+x^2, y+x, y\>$ using {\sc lex} ordering with $y>x$. The result
was $G=\{y^2+yx+x^2, y+x, y,x^2,x\}$.  Notice that we could in fact simply employ
the basis $\{x,y\}$. In other words the algorithm was far from optimal.  We can make
a number of improvements that will both produce a ``better" {\Gr} basis and do so
with greater efficiency.

One clear drawback of the algorithm is that we retain old elements of the basis even
when a new one is introduced whose leading term divides its leading term.

\begin{definition}
A {\Gr} basis $\{g_1,\dots,g_s\}$ is {\bf minimal} if 
\\[-1cm]
\begin{enumerate}
\item
$\forall\,i=1,\dots,s$, $\lc(g_i)=1$
\item
$\forall\,i\neq j$, $\lp(g_i)\nmid\lp(g_j)$.
\end{enumerate}
\end{definition}

A simple procedure for obtaining a minimal {\Gr} basis from a given one
$\{g_1,\dots,g_s\}$ is, for each
$i$ in turn delete $g_i$ if there exists $g_j$ such that $\lp(g_j)|\lp(g_i)$, else
replace $g_i$ by $g_i/\lc(g_i)$ to ensure it is monic.  In the example above,
$\{y,x\}$ is a minimal {\Gr} basis but so also is $\{y+x,x\}$. So minimal {\Gr}
bases are not unique. Nevertheless,

\begin{lemma}
\label{minimal}
If $G=\{g_1,\dots,g_s\}$ and $H=\{h_1,\dots,h_t\}$ are minimal {\Gr} bases for an
ideal $I$ then $s=t$ and $\{\lt(g_1),\dots,\lt(g_s)\}=\{\lt(h_1),\dots,\lt(h_t)\}$.
\end{lemma}
The proof is an assignment question. Which of the two minimal {\Gr} bases above is
``better"? One would probably say the first.  The reason for this is that in the
second, the element $y+x$ has a term divisible by the leading power of another
element.

\begin{definition}
A {\Gr} basis $G=\{g_1,\dots,g_s\}$ is {\bf reduced} if
\\[-1cm]
\begin{enumerate}
\item
$\forall\,i=1,\dots,s$, $\lc(g_i)=1$
\item
$\forall\,i=1,\dots,s$, $g_i$ is reduced with respect to $G-\{g_i\}$.
\end{enumerate}
\end{definition}
Note that a reduced {\Gr} basis is automatically a minimal one.  Here is a procedure
for generating a reduced basis from a minimal one:
\\[-1cm]
\begin{itemize}
\item
let $H_1=\{g_2,\dots,g_s\}$ and suppose $g_1\redplus{H_1}h_1$ then 
\item
let $H_2=\{h_1,g_3,\dots,g_s\}$ and reduce $g_2\redplus{H_2}h_2$ and so on\dots
\item
let $H_s=\{h_1,h_2,\dots,h_{s-1}\}$ and reduce
$g_s\redplus{H_s}h_s$
\item
Now $H=\{h_1,\dots,h_s\}$ is the required reduced {\Gr} basis.
\end{itemize}
The proof that this works is an assignment exercise.

\begin{theorem}
\label{reduced}
Given an ideal $I$ and a fixed term order, there is a {\rm unique} reduced {\Gr}
basis for $I$.
\end{theorem}

\begin{proof}
Existence follows from the procedure described above so we must prove uniqueness. 
Suppose $G=\{g_1,\dots,g_s\}$ and $H=\{h_1,\dots,h_t\}$ are reduced {\Gr} bases.
Since they are necessarily minimal, by Lemma~\ref{minimal} $s=t$ and we may assume
that $\lt(g_i)=\lt(h_i)$ for each $i=1,\dots, s$.

Suppose $g_i\neq h_i$ for some $i$. We know $g_i- h_i\in I$ so for some $j$,
$\lp(h_j)|\lp(g_i-h_i)$, but as $\lp(g_i-h_i)<\lp(h_i)=\lp(g_i)$, clearly $j\neq
i$.It follows that for some term of either $g_i$ or $h_i$ that $\lp(h_j)=\lp(g_j)$
divides it, contrary to the assumption that each is reduced. Thus $g_i=h_i$ for all
$i$.
\end{proof}

\subsection{Improving Efficiency (optional)}

The improvements of the preceding section provide us with better {\Gr} bases after
we have already used Buchberger's algorithm to generate {\it a\/} {\Gr} basis.  It
is also possible to adapt the algorithm itself to make it more efficient.  In fact
the reduction process can be implemented systematically during the algorithm.
Further efficiencies can be achieved by simplifying some of the decisions in the
algorithm.

The first efficiency is to note that in certain circumstances we can know that
$S(f,g)\redplus{G}0$ without performing the Division Algorithm.

\begin{lemma}
\label{signore}
Suppose $f,g\in G\subset\kn$ and $\lcm\{\lp(f),\lp(g)\}=\lp(f).\lp(g)$
(i.e. the leading powers of $f$ and $g$ are relatively prime). Then
$S(f,g)\redplus{G}0$.
\end{lemma}

\begin{proof}
We may as well assume that $f$ and $g$ are monic and let $f=\lp(f)+p$, $g=\lp(g)+q$.
Then
\begin{eqnarray}
S(f,g)&=&\lp(g)f-\lp(f)g\notag\\
&=&(g-q)f-(f-p)g=pg-qf.
\label{sreduce}
\end{eqnarray}
Moreover there is no cancellation of higher order terms in this representation of
$S(f,g)$. For suppose there were cancellation of the leading terms then
$$
\lp(p)\lp(g)=\lp(q)\lp(f).
$$
Given that $\lp(f)$ and $\lp(g)$ are relatively prime, this implies that
$\lp(g)|\lp(q)$ and hence $\lp(g)\leq\lp(q)$. But this contradicts the definition of
$q$.  

It follows that $\lp(S(f,g))=\max\{\lp(p)\lp(g),\lp(q)\lp(f)\}$ and hence, by
(\ref{sreduce}), that we can reduce $S(f,g)$ to $0$.
\end{proof}

We can go further by analysing more carefully the role of the S--polynomials. 
According to Cox, Little and O'Shea in their book ``Ideals, Algorithms and
Varieties", the term derives from the word {\bf syzygy}, meaning `yoke'. 

\begin{definition}
Given a set of polynomials $F=\{f_1,\dots,f_s\}$ a {\bf syzygy} on the leading terms
$\lt(f_1),\dots,\lt(f_s)$ is an $s$-tuple of polynomials $S=(h_1,\dots,h_s)$ such
that
\begin{equation}
\label{syz}
\sum_{i=1}^s h_i\lt(f_i)=0.
\end{equation}
Let $S(F)$ denote the set of all such syzygies.
\end{definition}

It is handy to think of $S$ as a vector $\sum_{i=1}^sh_i\be_i$ in the vector--like
space $\kn^s$ with basis vectors $\be_i=(0,\dots,0,1,0,\dots,0)$. Note that since
$\kn$ is not a field, but only a ring, in fact $\kn^s$ is really a {\it module\/}
rather than a vector space. Nevertheless, it is the case that every set of syzygies
$S(F)$ does have a finite basis with respect to coordinate-wise sums and
multiplication by polynomials (not just scalars). The S--polynomials can be seen as
examples of syzygies with
$$
S_{ij}=\frac l{\lt(f_i)}\be_i-\frac l{\lt(f_j)}\be_j.
$$
In fact, it can be shown that the $S_{ij}$, $i<j$, form a basis for $S(F)$---this is
roughly the interpretation of Theorem~1 of Section~7. We can now find a criterion for
reducing the basis along the lines of Lemma~\ref{signore}. 

\begin{theorem}
\label{simprove}
Given $G=\{g_1,\dots,g_t\}$, suppose $\cS\subset\{S_{ij}\,:\,1\leq i<j\leq t\}$ is a
basis for $S(G)$. If $i,j,k$ ($i<j$) are such that
$$
\lt(g_k)|\lcm\{\lt(g_i),\lt(g_j)\}
$$
then $\cS-\{S_{ij}\}$ is still a basis for $S(G)$.
\end{theorem}

\begin{proof}
Let $X_{ij}=\lcm\{\lp(g_i),\lp(g_j)\}$ and define $X_{ik}$, $X_{jk}$ similarly. By
hypothesis, $X_{ik},X_{jk}|X_{ij}$. It is straightforward to show that
$$
S_{ij}=\frac{X_{ij}}{X_{ik}}S_{ik}-\frac{X_{ij}}{X_{jk}}S_{jk}
$$
and the result follows.
\end{proof}

By way of an example, consider $G=\{g_1=x^2y^2+z,g_2=xy^2z-yz^3,g_3=x^2y+yz\}$ 
with {\sc lex} ordering and $x>y>z$. Now $\lp(g_1)=x^2y^2$ and
$\lcm\{\lp(g_2),\lp(g_3)\}=\lcm\{xy^2z,x^2y\}=x^2y^2z$. So the criterion in
Theorem~\ref{simprove} is satisfied and $\{S_{12},S_{13}\}$ is a basis for $S(G)$.
Explicitly,
$$
S_{12}=(z,-x,0),\qquad S_{13}=(1,0,-y),\qquad S_{23}=(0,x,-yz)
$$
and you can see that $S_{23}=zS_{13}-S_{12}$.

Further improvements can be made by judicious ordering of the polynomials. For
example, listing the $f_i$s in increasing order of $\lp(F_i)$ improves the speed of
the Division Algorithm by reducing the number of compasrisons that are required,
while listing pairs $\{f_i,f_j\}$ by increasing order of $\lcm\{\lp(f_i),\lp(f_j)\}$
tends to produce S--polynomials giving non-zero remainder sooner which is
apparently desirable.

Two deficiencies that tend to render the algorithm slow and sometimes impractical are
\begin{itemize}
\item
growth in the degrees of polynomials generated
\item
growth of complexity of coefficients (say, as rational numbers)
\end{itemize}
Some term orders tend to be better than others in this respect, notably {\sc
degrevlex}.


\end{document}
